unit NetWork_Types;

interface

uses
  Windows, WinSock2, KOL;

const
  COMMAND = #$FF#$FF#$FF#$FF;
  A2C_PRINT = #$FF#$FF#$FF#$FF+'l';
  A2M_GET_SERVERS_BATCH2 = $31;
  A2M_GET_SERVERS_IP: AnsiString = '0.0.0.0:0';
  S2C_CHALLENGE = $41;
  S2A_PLAYER = $44;
  S2A_RULES = $45;
  S2A_INFO = $49;
  S2A_LOG = $52;
  A2S_INFO = #$FF#$FF#$FF#$FF+'TSource Engine Query';
  A2S_INFO_LENGTH = 25;
  A2S_PLAYER = #$FF#$FF#$FF#$FF#$55;
  A2S_PLAYER_LENGTH = 5;
  A2S_PLAYER_CHALLENGE = #$FF#$FF#$FF#$FF#$55#$FF#$FF#$FF#$FF;
  A2S_RULES = #$FF#$FF#$FF#$FF#$56#$00#$00#$00#$00;
  A2S_RULES_CHALLENGE = #$FF#$FF#$FF#$FF#$56#$FF#$FF#$FF#$FF;
  A2S_RULES_LENGTH = 9;
  A2S_SERVERQUERY_GETCHALLENGE = #$FF#$FF#$FF#$FF#$57;
  A2S_SERVERQUERY_GETCHALLENGE_LENGTH = 5;
  M2A_SERVER_BATCH = $66;
  A2A_PING = #$FF#$FF#$FF#$FF#$69;
  A2A_PING_LENGTH = 5;
  A2A_ACK = $6a;
  PROTOCOL_VERSION = 2;

type
  pusint = ^usint;
  usint = word;

  pIP = ^TIP;
  TIP = record
      Port: word; 
      case integer of
        0: (IP: array[0..3] of byte);
        1: (uIP: uint);
    end;
    
  PTimeVal = ^TTimeVal;
  timeval = record
    tv_sec: Longint;
    tv_usec: Longint;
  end;

  TTimeVal = timeval;
  
  PFDSet = ^TFDSet;
  TFDSet = record
    fd_count: u_int;
    fd_array: array[0..FD_SETSIZE-1] of TSocket;
  end;
    
  TSock = record
      IP: TIP;
      AddrType: Smallint;
      Length: Smallint;
    end;

  pNewProtoName = ^TNewProtoName;
  TNewProtoName = record
        typ: array[0..5] of byte;
        name: array[0..11] of Ansichar;
    end;

  pOldProtoIp = ^TOldProtoIp;
  TOldProtoIp = record
      typ: array[0..4] of byte;
      IP: array[0..1] of Ansichar;
    end;

  pOldProtoData = ^TOldProtoData;
  TOldProtoData = record
      playusers,
      maxusers,
      protocol,
      typ,
      OS: byte;
    end;

  pOldProtoUrl = ^TOldProtoUrl;
  TOldProtoUrl = record
      typ: byte;
      url: array[0..11] of Ansichar;
    end;

  pNewProtoUsers = ^TNewProtoUsers;
  TNewProtoUsers = record
      users,
      protocol: byte;
    end;

  TRegionCode =
    (USEast = 00,
     USWest = 02,
     SouthAmerica = 03,
     Europe = 04,
     Asia = 04,
     Australia = 05,
     MiddleEast = 06,
     Africa = 07);

  TFilter =
    (IsDedicated = $0001,
     IsVAC = $0002,
     IsGamedir = $0004,
     IsMap = $0008,
     IsLinux = $0010,
     IsNotEmpty = $0020,
     IsNotFull = $0040,
     IsProxy = $0080,
     IsAppID = $0200);

  TOSType = (OS_Linux, OS_Windows);

  pPlayerReply = ^TPlayerReply;
  TPlayerReply = record
      checksum: byte;     //$44 ('D')
      NumPlayers: byte;
    end;

  pPlayer = ^TPlayer;
  TPlayer = record
      Idx: byte;
      PlayerName: string;
      Kills: uint;
      GameTime: single;
    end;

  pPlayerList = ^TPlayerList;
  TPlayerList = object (TList)
    private
      function GetItem(Idx: integer): pPlayer;
    public
      property Items[Idx: integer]: pPlayer read GetItem;
    end;

  TModInfo = record
      IsSvOnly,
      IsClDLL: boolean;
      Nul: byte;
      ModVersion,
      ModSize: LongInt;
      URLInfo,
      URLDL: pAnsiChar;
    end;
    
  pServerInfo = ^TServerInfo;
  TServerInfo = record
     //  
      IsDedicated,
      IsSecure,
      IsPassword,
      IsMod: boolean;
      OSType: TOSType;
      Typ,  
      NumberOfPlayers,
      MaxPlayers, 
      Version,
      NumberOfBots: byte;
      GameIP,
      ServerName,
      MapName,
      GameDirectory,
      GameDescription: string;
     //Source server
      AppID: word;
      EDF: byte;
     //The Thip server
      GameMode,
      WitnessCount,
      WitnessTime: byte;
      GameVersion: string;

      Players: pPlayerList;
      Challenge: uint;
      IP: TIP;
      ModInfo: TModInfo;
    end;

  pIPList = ^TIPList;
  TIPList = object (TList)
    private
      function GetItem(Idx: integer): pIP;
    public
      property Items[Idx: integer]: pIP read GetItem;
    end;

var
  SSQ_UDP_MS,
  SSQ_UDP_GS,
  SSQ_UDP_S: TSocket;

implementation 

function TIPList.GetItem(Idx: integer): pIP;
begin
  result:=Get(Idx);
end;

function TPlayerList.GetItem(Idx: integer): pPlayer;
begin
  result:=Get(Idx);
end;


end.
