unit Steam_MasterServerClient;

interface

uses
  Windows, WinSock2, KOL,
    utils, NetWork_Types;

type
  pMasterServerClient = ^TMasterServerClient;
  TMasterServerClient = object (TObj)
    private
      fIPAddr: TIP;
    public
      ServersList: pIPList;
      function Initializations(Server: Ansistring): boolean;

      procedure GetServerList(commands: Ansistring; Region: byte);

      destructor Destroy; virtual;
    end;
    
function NewMasterServerClient: pMasterServerClient;

implementation 

{const
  MRSG = #$31#$FF#$30#$2E#$30#$2E#$30#$2E#$30#$3A#$30#$00;    }

function NewMasterServerClient: pMasterServerClient;
begin
  new(Result, Create);
  New(result.ServersList, Create);
end;

function TMasterServerClient.Initializations(Server: Ansistring): boolean;
var
  Host: PHostEnt;
  ServerAddr: Ansistring;
  WSA: TWSAData;
begin        
  result:=false;
  ServerAddr:=Parse(Server, ':');
  fIPAddr.Port:=Str2Int(Server);

  if WSAStartup(MAKEWORD(2,2), WSA)<>0 then
    Exit;

  Host:=GetHostByName(pAnsiChar(ServerAddr));
  if Host=nil then
    Exit;
  Move(Host^.h_address_list^[0], fIPAddr.IP[0], 4);

  SSQ_UDP_MS:=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);

  result:=true;
end;

procedure TMasterServerClient.GetServerList(commands: Ansistring; Region: byte);
var
  SendLength, n: integer;
  IPAddr, host_ip: uint;
  IP: pIP;
  p, ipadres: pAnsiChar;
  StartIP: AnsiString;
  hp: pHOSTENT;
  dest_addr: sockaddr_in;
  RecvBuf: array[0..10023] of byte;
  mess: array[0..10023] of AnsiChar;
begin
  StartIP:=A2M_GET_SERVERS_IP;
  
  //Move(MRSG, Mess[0], Length(MRSG)-1);
  //Move(commands[1], Mess[Length(MRSG)-1], Length(commands));

  dest_addr.sin_family:=AF_INET;
  dest_addr.sin_port:=htons(fIPAddr.Port);
  dest_addr.sin_addr.S_addr:=inet_addr(pAnsiChar(Arr2Str(fIPAddr.IP)));
  if dest_addr.sin_addr.S_addr=INADDR_NONE then
    Exit;
  if connect(SSQ_UDP_MS, @dest_addr, sizeof(TSockAddrIn))=SOCKET_ERROR then
    Exit;

  n:=1;
  while n>0 do
  begin
    SendLength:=5+Length(StartIP)+Length(commands);
    FillChar(Mess[0], SendLength, 0);
    Mess[0]:=AnsiChar(A2M_GET_SERVERS_BATCH2);
    Mess[1]:=AnsiChar(region);
    Move(StartIP[1], Mess[2], Length(StartIP));
    Move(commands[1], Mess[3+Length(A2M_GET_SERVERS_IP)], Length(commands));
    if send(SSQ_UDP_MS, Mess[0], SendLength, 0)=SOCKET_ERROR then
      Exit;

    n:=recv(SSQ_UDP_MS, RecvBuf, sizeof(RecvBuf), 0);
    if n<6 then
      break;
      
    p:=@RecvBuf[6];
    repeat
      IPAddr:=puint(p)^;
      if IPAddr=$ffffffff then
      begin
        dec(n, 6);
        inc(p, 6);
        continue;
      end;
      if IPAddr=0 then
        break;
      
      New(IP);
      IP.Port:=ntohs(pusint(@p[4])^);
      ipadres:=inet_ntoa(pinaddr(p)^);
      host_ip:=inet_addr(ipadres);
      if host_ip=INADDR_NONE then
      begin
        hp:=gethostbyname(ipadres);
        host_ip:=puint(hp^.h_addr)^;
      end;
      IP.uIP:=host_ip;
      //Int2Arr(host_ip, IP^.IP);
      if (IP.IP[0]=0) then
      begin
        dec(n, 6);
        inc(p, 6);
        continue;
      end;
      ServersList.Add(IP);
      writeln(Arr2Str(IP.IP),':',Int2Str(IP.Port));

      StartIP:=Arr2Str(IP.IP)+':'+Int2Str(IP.Port);
      dec(n, 6);
      inc(p, 6);
    until n<6;
    n:=1;
    break;
  end;
  CloseSocket(SSQ_UDP_MS);
end;

destructor TMasterServerClient.Destroy;
var
  i: integer;
begin
  if ServersList.Count>0 then
    for i:=0 to ServersList.Count-1 do
      FreeMem(ServersList.Items[i], sizeof(TIP));
  ServersList.Free;
  if SSQ_UDP_MS<>0 then
    closesocket(SSQ_UDP_MS);
  inherited;
end;


end.
