function TSteamNetWork.UpdateCDR(FileName: pAnsiChar; IPAddr: TIP): boolean;
var
  bAccepted: boolean;
  uCDRSize, uDataRead, uRet: integer;
  szBuffer, szCDR: pByte;
  Stream: pStream;
  szData: array[0..25] of byte;
  Sock: TSocket;
  SHA: pSHA1;
  i: integer;
begin  
  result:=false;

  bAccepted:=false;
  CF_CLIENTVER:=2;
  uCDRSize:=0;
  Sock:=Socket(fConfigServer.AddrType, fConfigServer.Length, IPPROTO_IP);
  if not Connect(Sock, pAnsiChar(Arr2Str(IPAddr.IP)), IPAddr.Port) then
    Exit;
  if send(Sock, CF_CLIENTVER, 4, 0)=SOCKET_ERROR then
    Exit;
  if recv(Sock, bAccepted, 1, 0)=SOCKET_ERROR then
    Exit;
  if not bAccepted then
    Exit;
  FillChar(szData, 25, 0);
  if recv(Sock, szData[0], 4, 0)=SOCKET_ERROR then
    Exit;
  FillChar(szData, 25, 0);
  szData[3]:=$15;
  szData[4]:=$09;
  SHA:=NewSHA1;
  SHA.HashFile(FileName);
  memcpy(@szData[5], SHA.GetDigest, 20);
  SHA.Free;   
  for i:=0 to 24 do
    Write(Int2Hex(ord(szData[i]), 2));
  Writeln('');
  if send(Sock, szData, 25, 0)=SOCKET_ERROR then
    Exit;
  FillChar(szData, 11, 0);
  if recv(Sock, szData, 11, 0)=SOCKET_ERROR then
    Exit;    
  for i:=0 to 11 do
    Write(Int2Hex(ord(szData[i]), 2));
  if recv(Sock, uCDRSize, 4, 0)=SOCKET_ERROR then
    Exit;
  uCDRSize:=ntohl(uCDRSize);

  if uCDRSize<>0 then
  begin
    uDataRead:=0;
    GetMem(szCDR, uCDRSize);
    szBuffer:=szCDR;
    while uDataRead<uCDRSize do
    begin
      uRet:=recv(Sock, szBuffer^, 1024, 0);
      if uRet=SOCKET_ERROR then
        break;
      inc(uDataRead, uRet);
      inc(szBuffer, uRet);
    end;
    Stream:=NewWriteFileStream(FileName);
    Stream.Write(szCDR^, uCDRSize);
    Stream.Free;
    FreeMem(szCDR);
  end;
         
  CloseSocket(Sock);
  result:=true;
end;
