unit Steam_ServerClient;

interface

uses
  Windows, WinSock2, KOL,
    utils, NetWork_Types;

type
  pServerClient = ^TServerClient;
  TServerClient = object (TObj)
    private       
      Mess: pAnsiChar;
      Address: TIP;
      fServerInfo: TServerInfo;
      hlserver_addr: TSockAddrIn;
      function fConnectToServer(Addr: TIP): boolean;
    public
      function GetServerInfo: pServerInfo;
      function PingServer: integer;
      procedure GetPlayersList;
      procedure PrintMessage(Msg: Ansistring);
    end;
    
function NewServerClient(Addr: TIP): pServerClient;

implementation

function NewServerClient(Addr: TIP): pServerClient;
begin
  New(Result, Create); 
  GetMem(result.Mess, 65535);
  FillChar(result.Mess^, 65535, 0);
  result.fConnectToServer(Addr)
end;

function TServerClient.fConnectToServer(Addr: TIP): boolean;
begin
  result:=false;

  hlserver_addr.sin_family:=AF_INET;
  hlserver_addr.sin_port:=htons(Addr.Port);
  hlserver_addr.sin_addr.S_addr:=Addr.uIP;
  SSQ_UDP_GS:=Socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
  if connect(SSQ_UDP_GS, @hlserver_addr, sizeof(TSockAddrIn))=SOCKET_ERROR then
    Exit;

 { SSQ_UDP_S:=Socket(AF_INET, SOCK_DGRAM, IPPROTO_IP);  
  if connect(SSQ_UDP_S, @hlserver_addr, sizeof(TSockAddrIn))=SOCKET_ERROR then
    Exit;       }

  {Move(A2S_SERVERQUERY_GETCHALLENGE, Mess[0], A2S_SERVERQUERY_GETCHALLENGE_LENGTH);
  if send(SSQ_UDP_GS, Mess[0], A2S_SERVERQUERY_GETCHALLENGE_LENGTH, 0)=SOCKET_ERROR then
    Exit;
  if recv(SSQ_UDP_GS, Mess[0], 9, 0)=SOCKET_ERROR then
    Exit;
  Move(Mess[5], fServerInfo.Challenge, 4); 
         }
  result:=true;
end;   

function TServerClient.GetServerInfo: pServerInfo;
var
  SendLength, numbyte: integer;
  abuffer: pAnsiChar;
  ClBuf: array[0..10023] of byte;

  ServerInfo: pServerInfo;
begin
  result:=nil;

  Mess:=A2S_INFO;
  SendLength:=A2S_INFO_LENGTH;
  if send(SSQ_UDP_GS, Mess[0], SendLength, 0)=SOCKET_ERROR then
    Exit;
  numbyte:=recv(SSQ_UDP_GS, ClBuf[0], sizeof(ClBuf), 0);   

  if numbyte<1 then
    Exit;  

  New(ServerInfo);
  New(ServerInfo.Players, Create);
  ServerInfo.Challenge:=0;

  if ClBuf[4]=$6D then
  begin
    //Goldsource servers 
    ServerInfo.Typ:=ClBuf[4];
    abuffer:=@ClBuf[5];
    ServerInfo^.GameIP:=abuffer;                inc(abuffer, Length(abuffer)+1);
    ServerInfo.ServerName:=abuffer;             inc(abuffer, Length(abuffer)+1);
    ServerInfo.MapName:=abuffer;                inc(abuffer, Length(abuffer)+1);
    ServerInfo.GameDirectory:=abuffer;          inc(abuffer, Length(abuffer)+1);
    ServerInfo.GameDescription:=abuffer;        inc(abuffer, Length(abuffer)+1);
    ServerInfo.NumberOfPlayers:=ord(abuffer[0]);inc(abuffer, 1);
    ServerInfo.MaxPlayers:=ord(abuffer[0]);     inc(abuffer, 1);
    ServerInfo.Version:=ord(abuffer[0]);        inc(abuffer, 1);
    ServerInfo.IsDedicated:=boolean(abuffer[0]);inc(abuffer, 1);
    if abuffer[0]='l' then ServerInfo.OSType:=OS_Linux
      else ServerInfo.OSType:=OS_Windows;       inc(abuffer, 1);
    ServerInfo.IsPassword:=boolean(abuffer[0]); inc(abuffer, 1);
    ServerInfo.IsMod:=boolean(abuffer[0]);      inc(abuffer, 1);
    ServerInfo.IsSecure:=boolean(abuffer[0]);   inc(abuffer, 1);
    ServerInfo.NumberOfBots:=ord(abuffer[0]);   inc(abuffer, 1);
    if ServerInfo.IsMod then
    begin
      ServerInfo.ModInfo.URLInfo:=abuffer;      inc(abuffer, Length(abuffer)+1);
      ServerInfo.ModInfo.URLDL:=abuffer;        inc(abuffer, Length(abuffer)+1);
      ServerInfo.ModInfo.Nul:=ord(abuffer[0]);  inc(abuffer, 1);
      ServerInfo.ModInfo.ModVersion:=pLongInt(abuffer)^;inc(abuffer, 2);
      ServerInfo.ModInfo.ModSize:=pLongInt(abuffer)^;inc(abuffer, 2);
      ServerInfo.ModInfo.IsSvOnly:=boolean(abuffer[0]);inc(abuffer, 1);
      ServerInfo.ModInfo.IsClDLL:=boolean(abuffer[0]);inc(abuffer, 1);
    end;
  end
    else if ClBuf[4]=$49 then
  begin  
    ServerInfo.Typ:=ClBuf[4];
    abuffer:=@ClBuf[5];
    ServerInfo.Version:=ord(abuffer[0]);        inc(abuffer, 1);
    ServerInfo.ServerName:=abuffer;             inc(abuffer, Length(abuffer)+1);
    ServerInfo.MapName:=abuffer;                inc(abuffer, Length(abuffer)+1);
    ServerInfo.GameDirectory:=abuffer;          inc(abuffer, Length(abuffer)+1);
    ServerInfo.GameDescription:=abuffer;        inc(abuffer, Length(abuffer)+1);
    ServerInfo.AppID:=pLongInt(abuffer)^;       inc(abuffer, 2);    
    ServerInfo.NumberOfPlayers:=ord(abuffer[0]);inc(abuffer, 1);
    ServerInfo.MaxPlayers:=ord(abuffer[0]);     inc(abuffer, 1);   
    ServerInfo.NumberOfBots:=ord(abuffer[0]);   inc(abuffer, 1);
    ServerInfo.IsDedicated:=boolean(abuffer[0]);inc(abuffer, 1);
    if abuffer[0]='l' then ServerInfo.OSType:=OS_Linux
      else ServerInfo.OSType:=OS_Windows;       inc(abuffer, 1);
    ServerInfo.IsPassword:=boolean(abuffer[0]); inc(abuffer, 1);
    ServerInfo.IsSecure:=boolean(abuffer[0]);   inc(abuffer, 1);
    if abuffer[0]>#$20 then
    begin
      //Source server
      ServerInfo.GameVersion:=abuffer;          inc(abuffer, Length(abuffer)+1);
      ServerInfo.EDF:=ord(abuffer[0]);          inc(abuffer, 1);  
    end
      else
    begin
      //The Ship server
      ServerInfo.GameMode:=ord(abuffer[0]);     inc(abuffer, 1);
      ServerInfo.WitnessCount:=ord(abuffer[0]); inc(abuffer, 1);
      ServerInfo.WitnessTime:=ord(abuffer[0]);  inc(abuffer, 1);
      ServerInfo.GameVersion:=abuffer;          inc(abuffer, Length(abuffer)+1);
    end;
  end;  

  ServerInfo.IP:=Address;

  result:=ServerInfo;
  fServerInfo:=result^;
end;

function TServerClient.PingServer: integer;
var
  SendLength: integer;
  Ping: dword;
  fd_read, fd_error: TFDSet;
  newtimeout: timeval;
begin
  result:=-1;

  newtimeout.tv_sec:=5;
  newtimeout.tv_usec:=0;
  fd_error.fd_array[0]:=SSQ_UDP_GS;
  fd_error.fd_count:=1;
  fd_read.fd_array[0]:=SSQ_UDP_GS;
  fd_read.fd_count:=1;

  Move(A2A_PING, Mess[0], A2A_PING_LENGTH);
  ping:=GetTickCount;
  if send(SSQ_UDP_GS, Mess[0], A2A_PING_LENGTH, 0)=SOCKET_ERROR then
    Exit;
  SendLength:=-1;
  while select(0, @fd_read, 0, @fd_error, @newtimeout)>0 do
    SendLength:=recv(SSQ_UDP_GS, Mess[0], 16, 0);
  if ord(Mess[4])<>A2A_ACK then
    Exit;
  result:=GetTickCount-Ping;
  if SendLength=-1 then
    result:=-1;
end;

procedure TServerClient.GetPlayersList;
var
  SendLength, i: integer;
  PlayerReply: TPlayerReply;
  Player: pPlayer;
  p: pAnsiChar;
begin
  p:=Mess;

  Move(A2S_PLAYER, Mess[0], A2S_PLAYER_LENGTH);
  Move(fServerInfo.Challenge, Mess[5], 4);
  if send(SSQ_UDP_GS, Mess[0], A2S_PLAYER_LENGTH+4, 0)=SOCKET_ERROR then
    Exit;
  SendLength:=recv(SSQ_UDP_GS, Mess[0], 65535, 0);
  PlayerReply:=pPlayerReply(@Mess[4])^;
  if (SendLength=(SOCKET_ERROR or 0)) or (PlayerReply.checksum<>S2A_PLAYER) then
    Exit;
  Mess:=@p[6];
  if PlayerReply.NumPlayers>0 then
    for i:=0 to PlayerReply.NumPlayers-1 do
    begin
      New(Player);
      Player.Idx:=ord(Mess[0]);           inc(Mess, 1);
      Player.PlayerName:=Mess;            inc(Mess, Length(Player.PlayerName)+1);
      Player.Kills:=puint(Mess)^;         inc(Mess, 4);
      Player.GameTime:=psingle(@Mess)^;   inc(Mess, 4);
      fServerInfo.Players.Add(Player);
    end;
  FreeMem(p, 65535);
end;

procedure TServerClient.PrintMessage(Msg: Ansistring);
  //ServerMsg: string;
begin
 { ServerMsg:='prot\2\raw\32\name\andreil\';
  GetMem(Mess, 65535);
  FillChar(Mess^, 65535, 0);
  Move(pChar(#$FF#$FF#$FF#$FF#$63#$6F#$6E#$6E#$65#$63#$74)^, Mess[0], 11);
  Mess[11]:=#13;
  Mess[12]:=#2;   
  Mess[13]:=#13;
  Move(fServerInfo.Challenge, Mess[14], 4);
  Mess[18]:=#13;
  Move(ServerMsg[1], Mess[19], length(ServerMsg));

  if sendto(SSQ_UDP_S, Mess[0], 19+length(ServerMsg), 0, @hlserver_addr, sizeof(hlserver_addr))=SOCKET_ERROR then
    Exit;      }

  Move(A2C_PRINT, Mess[0], 5);
  Mess[5]:=#13;
  Move(Msg[1], Mess[6], Length(Msg));
  Mess[length(Msg)+6]:=#13;
  Mess[length(Msg)+7]:=#10;
  Mess[length(Msg)+8]:=#0;
  send(SSQ_UDP_S, Mess[0], length(Msg)+8, 0);
end;


end.
